searchData={"items":[{"type":"module","title":"Yex","doc":"Yex is wrapper library for the Yjs CRDT library.","ref":"Yex.html"},{"type":"function","title":"Yex.apply_update/2","doc":"Apply a document update on the shared document.","ref":"Yex.html#apply_update/2"},{"type":"function","title":"Examples Sync two clients by exchanging the complete document structure - Yex.apply_update/2","doc":"iex> doc1 = Yex.Doc.new()\n    iex> doc2 = Yex.Doc.new()\n    iex> {:ok, state1} = Yex.encode_state_as_update(doc1)\n    iex> {:ok, state2} = Yex.encode_state_as_update(doc2)\n    iex> Yex.apply_update(doc1, state2)\n    :ok\n    iex> Yex.apply_update(doc2, state1)\n    :ok","ref":"Yex.html#apply_update/2-examples-sync-two-clients-by-exchanging-the-complete-document-structure"},{"type":"function","title":"Yex.apply_update_v1/2","doc":"","ref":"Yex.html#apply_update_v1/2"},{"type":"function","title":"Yex.apply_update_v2/2","doc":"","ref":"Yex.html#apply_update_v2/2"},{"type":"function","title":"Yex.encode_state_as_update/2","doc":"Encode the document state as a single update message that can be applied on the remote document. Optionally, specify the target state vector to only write the missing differences to the update message.","ref":"Yex.html#encode_state_as_update/2"},{"type":"function","title":"Examples - Yex.encode_state_as_update/2","doc":"iex> doc = Yex.Doc.new()\n    iex> {:ok, _binary} = Yex.encode_state_as_update(doc)","ref":"Yex.html#encode_state_as_update/2-examples"},{"type":"function","title":"Yex.encode_state_as_update!/2","doc":"@see encode_state_as_update/2","ref":"Yex.html#encode_state_as_update!/2"},{"type":"function","title":"Yex.encode_state_as_update_v1/2","doc":"","ref":"Yex.html#encode_state_as_update_v1/2"},{"type":"function","title":"Yex.encode_state_as_update_v2/2","doc":"","ref":"Yex.html#encode_state_as_update_v2/2"},{"type":"function","title":"Yex.encode_state_vector/1","doc":"Computes the state vector and encodes it into an Binary.\nA state vector describes the state of the local client.\nThe remote client can use this to exchange only the missing differences.","ref":"Yex.html#encode_state_vector/1"},{"type":"function","title":"Examples - Yex.encode_state_vector/1","doc":"iex> doc = Yex.Doc.new()\n    iex> {:ok, _binary} = Yex.encode_state_vector(doc)","ref":"Yex.html#encode_state_vector/1-examples"},{"type":"function","title":"Yex.encode_state_vector!/1","doc":"@see encode_state_vector/1","ref":"Yex.html#encode_state_vector!/1"},{"type":"function","title":"Yex.encode_state_vector_v1/1","doc":"","ref":"Yex.html#encode_state_vector_v1/1"},{"type":"function","title":"Yex.encode_state_vector_v2/1","doc":"","ref":"Yex.html#encode_state_vector_v2/1"},{"type":"type","title":"Yex.input_type/0","doc":"","ref":"Yex.html#t:input_type/0"},{"type":"module","title":"Yex.Array","doc":"A shareable Array-like type that supports efficient insert/delete of elements at any position.","ref":"Yex.Array.html"},{"type":"function","title":"Yex.Array.delete/2","doc":"Delete content at the specified index.","ref":"Yex.Array.html#delete/2"},{"type":"function","title":"Yex.Array.delete_range/3","doc":"Delete contents in the specified range.","ref":"Yex.Array.html#delete_range/3"},{"type":"function","title":"Yex.Array.fetch/2","doc":"Get content at the specified index.","ref":"Yex.Array.html#fetch/2"},{"type":"function","title":"Yex.Array.fetch!/2","doc":"","ref":"Yex.Array.html#fetch!/2"},{"type":"function","title":"Yex.Array.get/2","doc":"Get content at the specified index.","ref":"Yex.Array.html#get/2"},{"type":"function","title":"Examples Sync two clients by exchanging the complete document structure - Yex.Array.get/2","doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.push(array, \"Hello\")\n    iex> Yex.Array.get(array, 0)\n    {:ok, \"Hello\"}","ref":"Yex.Array.html#get/2-examples-sync-two-clients-by-exchanging-the-complete-document-structure"},{"type":"function","title":"Yex.Array.insert/3","doc":"Insert content at the specified index.","ref":"Yex.Array.html#insert/3"},{"type":"function","title":"Yex.Array.length/1","doc":"Returns the length of the array","ref":"Yex.Array.html#length/1"},{"type":"function","title":"Examples Sync two clients by exchanging the complete document structure - Yex.Array.length/1","doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.push(array, \"Hello\")\n    iex> Yex.Array.push(array, \"World\")\n    iex> Yex.Array.length(array)\n    2","ref":"Yex.Array.html#length/1-examples-sync-two-clients-by-exchanging-the-complete-document-structure"},{"type":"function","title":"Yex.Array.push/2","doc":"Push content to the end of the array.","ref":"Yex.Array.html#push/2"},{"type":"function","title":"Yex.Array.to_json/1","doc":"Convert to json-compatible format.","ref":"Yex.Array.html#to_json/1"},{"type":"function","title":"Examples Sync two clients by exchanging the complete document structure - Yex.Array.to_json/1","doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.push(array, \"Hello\")\n    iex> Yex.Array.push(array, \"World\")\n    iex> Yex.Array.to_json(array)\n    [\"Hello\", \"World\"]","ref":"Yex.Array.html#to_json/1-examples-sync-two-clients-by-exchanging-the-complete-document-structure"},{"type":"function","title":"Yex.Array.to_list/1","doc":"Returns as list","ref":"Yex.Array.html#to_list/1"},{"type":"function","title":"Examples Sync two clients by exchanging the complete document structure - Yex.Array.to_list/1","doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.push(array, \"Hello\")\n    iex> Yex.Array.push(array, \"World\")\n    iex> Yex.Array.push(array, Yex.ArrayPrelim.from([1, 2]))\n    iex> [\"Hello\", \"World\", %Yex.Array{}] = Yex.Array.to_list(array)","ref":"Yex.Array.html#to_list/1-examples-sync-two-clients-by-exchanging-the-complete-document-structure"},{"type":"function","title":"Yex.Array.unshift/2","doc":"Unshift content to the beginning of the array.","ref":"Yex.Array.html#unshift/2"},{"type":"type","title":"Yex.Array.t/0","doc":"","ref":"Yex.Array.html#t:t/0"},{"type":"module","title":"Yex.ArrayPrelim","doc":"A preliminary array. It can be used to early initialize the contents of a Array.","ref":"Yex.ArrayPrelim.html"},{"type":"module","title":"Examples - Yex.ArrayPrelim","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"key\", Yex.ArrayPrelim.from([\"Hello\", \"World\"]))\n    iex> {:ok, %Yex.Array{} = array} = Yex.Map.fetch(map, \"key\")\n    iex> Yex.Array.fetch(array, 1)\n    {:ok, \"World\"}","ref":"Yex.ArrayPrelim.html#module-examples"},{"type":"function","title":"Yex.ArrayPrelim.from/1","doc":"","ref":"Yex.ArrayPrelim.html#from/1"},{"type":"type","title":"Yex.ArrayPrelim.t/0","doc":"","ref":"Yex.ArrayPrelim.html#t:t/0"},{"type":"module","title":"Yex.Awareness","doc":"","ref":"Yex.Awareness.html"},{"type":"module","title":"Examples - Yex.Awareness","doc":"iex> doc = Yex.Doc.new()\n    iex> {:ok, _awareness} = Yex.Awareness.new(doc)","ref":"Yex.Awareness.html#module-examples"},{"type":"function","title":"Yex.Awareness.apply_update/3","doc":"Applies an update (incoming from remote channel or generated using [Awareness.encode_update] method) and modifies a state of a current instance.","ref":"Yex.Awareness.html#apply_update/3"},{"type":"function","title":"Examples - Yex.Awareness.apply_update/3","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.new())\n    iex> Yex.Awareness.clean_local_state(awareness)\n    iex> Yex.Awareness.apply_update(awareness, <<1, 210, 165, 202, 167, 8, 1, 2, 123, 125>>)\n    :ok\n    iex> Yex.Awareness.get_client_ids(awareness)\n    [2230489810]","ref":"Yex.Awareness.html#apply_update/3-examples"},{"type":"function","title":"Yex.Awareness.clean_local_state/1","doc":"","ref":"Yex.Awareness.html#clean_local_state/1"},{"type":"function","title":"Examples - Yex.Awareness.clean_local_state/1","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.with_options(%Yex.Doc.Options{ client_id: 100 }))\n    iex> Yex.Awareness.clean_local_state(awareness)\n    iex> Yex.Awareness.get_client_ids(awareness)\n    []","ref":"Yex.Awareness.html#clean_local_state/1-examples"},{"type":"function","title":"Yex.Awareness.client_id/1","doc":"","ref":"Yex.Awareness.html#client_id/1"},{"type":"function","title":"Yex.Awareness.demonitor_change/1","doc":"","ref":"Yex.Awareness.html#demonitor_change/1"},{"type":"function","title":"Yex.Awareness.demonitor_update/1","doc":"","ref":"Yex.Awareness.html#demonitor_update/1"},{"type":"function","title":"Yex.Awareness.encode_update/2","doc":"","ref":"Yex.Awareness.html#encode_update/2"},{"type":"function","title":"Examples - Yex.Awareness.encode_update/2","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.with_options(%Yex.Doc.Options{ client_id: 10 }))\n    iex> Yex.Awareness.set_local_state(awareness, %{ \"key\" => \"value\" })\n    iex> Yex.Awareness.encode_update(awareness, [10])\n    {:ok, <<1, 10, 1, 15, 123, 34, 107, 101, 121, 34, 58, 34, 118, 97, 108, 117, 101, 34, 125>>}","ref":"Yex.Awareness.html#encode_update/2-examples"},{"type":"function","title":"Yex.Awareness.get_client_ids/1","doc":"","ref":"Yex.Awareness.html#get_client_ids/1"},{"type":"function","title":"Examples - Yex.Awareness.get_client_ids/1","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.new())\n    iex> Yex.Awareness.apply_update(awareness, <<1, 210, 165, 202, 167, 8, 1, 2, 123, 125>>)\n    iex> Yex.Awareness.get_client_ids(awareness)\n    [2230489810]","ref":"Yex.Awareness.html#get_client_ids/1-examples"},{"type":"function","title":"Yex.Awareness.get_local_state/1","doc":"get local state of the current client","ref":"Yex.Awareness.html#get_local_state/1"},{"type":"function","title":"Examples - Yex.Awareness.get_local_state/1","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.with_options(%Yex.Doc.Options{ client_id: 100 }))\n    iex> Yex.Awareness.get_states(awareness)\n    %{}","ref":"Yex.Awareness.html#get_local_state/1-examples"},{"type":"function","title":"Yex.Awareness.get_states/1","doc":"","ref":"Yex.Awareness.html#get_states/1"},{"type":"function","title":"Examples - Yex.Awareness.get_states/1","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.with_options(%Yex.Doc.Options{ client_id: 100 }))\n    iex> Yex.Awareness.set_local_state(awareness, %{ \"key\" => \"value\" })\n    iex> Yex.Awareness.get_states(awareness)\n    %{100 => %{\"key\" => \"value\"}}","ref":"Yex.Awareness.html#get_states/1-examples"},{"type":"function","title":"Yex.Awareness.monitor_change/1","doc":"Listen to remote and local state changes. Get notified when a state is either added, updated, or removed.","ref":"Yex.Awareness.html#monitor_change/1"},{"type":"function","title":"Examples - Yex.Awareness.monitor_change/1","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.with_options(%Yex.Doc.Options{ client_id: 10 }))\n    iex> Yex.Awareness.monitor_change(awareness)\n    iex> Yex.Awareness.apply_update(awareness, <<1, 210, 165, 202, 167, 8, 1, 2, 123, 125>>)\n    iex> receive do {:awareness_change, %{removed: [], added: [2230489810], updated: []}, _origin, _awareness} -> :ok end","ref":"Yex.Awareness.html#monitor_change/1-examples"},{"type":"function","title":"Yex.Awareness.monitor_update/1","doc":"Monitor to remote and local awareness changes. This event is called even when the awareness state does not change but is only updated to notify other users that this client is still online. Use this event if you want to propagate awareness state to other users.","ref":"Yex.Awareness.html#monitor_update/1"},{"type":"function","title":"Examples - Yex.Awareness.monitor_update/1","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.with_options(%Yex.Doc.Options{ client_id: 10 }))\n    iex> Yex.Awareness.monitor_update(awareness)\n    iex> Yex.Awareness.set_local_state(awareness, %{ \"key\" => \"value\" })\n    iex> receive do {:awareness_update, %{removed: [], added: [10], updated: []}, _origin, _awareness} -> :ok end","ref":"Yex.Awareness.html#monitor_update/1-examples"},{"type":"function","title":"Yex.Awareness.new/1","doc":"create a new awareness instance","ref":"Yex.Awareness.html#new/1"},{"type":"function","title":"Yex.Awareness.remove_states/2","doc":"Clears out a state of a given client, effectively marking it as disconnected.","ref":"Yex.Awareness.html#remove_states/2"},{"type":"function","title":"Examples - Yex.Awareness.remove_states/2","doc":"iex> {:ok, _awareness} = Yex.Awareness.new(Yex.Doc.new())","ref":"Yex.Awareness.html#remove_states/2-examples"},{"type":"function","title":"Yex.Awareness.set_local_state/2","doc":"","ref":"Yex.Awareness.html#set_local_state/2"},{"type":"function","title":"Examples - Yex.Awareness.set_local_state/2","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.with_options(%Yex.Doc.Options{ client_id: 100 }))\n    iex> Yex.Awareness.set_local_state(awareness, %{ \"key\" => \"value\" })\n    iex> Yex.Awareness.get_states(awareness)\n    %{100 => %{\"key\" => \"value\"}}","ref":"Yex.Awareness.html#set_local_state/2-examples"},{"type":"type","title":"Yex.Awareness.t/0","doc":"","ref":"Yex.Awareness.html#t:t/0"},{"type":"module","title":"Yex.Doc","doc":"","ref":"Yex.Doc.html"},{"type":"function","title":"Yex.Doc.demonitor_update/1","doc":"Stop monitoring document updates.","ref":"Yex.Doc.html#demonitor_update/1"},{"type":"function","title":"Yex.Doc.demonitor_update_v1/1","doc":"","ref":"Yex.Doc.html#demonitor_update_v1/1"},{"type":"function","title":"Yex.Doc.demonitor_update_v2/1","doc":"","ref":"Yex.Doc.html#demonitor_update_v2/1"},{"type":"function","title":"Yex.Doc.get_array/2","doc":"Get or insert the array type.","ref":"Yex.Doc.html#get_array/2"},{"type":"function","title":"Yex.Doc.get_map/2","doc":"Get or insert the map type.","ref":"Yex.Doc.html#get_map/2"},{"type":"function","title":"Yex.Doc.get_text/2","doc":"Get or insert the text type.","ref":"Yex.Doc.html#get_text/2"},{"type":"function","title":"Yex.Doc.get_xml_fragment/2","doc":"Get or insert the xml fragment type.","ref":"Yex.Doc.html#get_xml_fragment/2"},{"type":"function","title":"Yex.Doc.monitor_update/1","doc":"Monitor document updates.","ref":"Yex.Doc.html#monitor_update/1"},{"type":"function","title":"Yex.Doc.monitor_update_v1/1","doc":"","ref":"Yex.Doc.html#monitor_update_v1/1"},{"type":"function","title":"Yex.Doc.monitor_update_v2/1","doc":"","ref":"Yex.Doc.html#monitor_update_v2/1"},{"type":"function","title":"Yex.Doc.new/0","doc":"Create a new document.","ref":"Yex.Doc.html#new/0"},{"type":"function","title":"Yex.Doc.transaction/3","doc":"Start a transaction.","ref":"Yex.Doc.html#transaction/3"},{"type":"function","title":"Examples - Yex.Doc.transaction/3","doc":"iex> doc = Doc.new()\n    iex> text = Doc.get_text(doc, \"text\")\n    iex> Yex.Doc.monitor_update(doc)\n    iex> Doc.transaction(doc, fn ->\n    iex>   Text.insert(text, 0, \"Hello\")\n    iex>   Text.insert(text, 0, \"Hello\", %{\"bold\" => true})\n    iex> end)\n    iex> assert_receive {:update_v1, _, nil, _}\n    iex> refute_receive {:update_v1, _, nil, _} # only one update message","ref":"Yex.Doc.html#transaction/3-examples"},{"type":"function","title":"Yex.Doc.with_options/1","doc":"Create a new document with options.","ref":"Yex.Doc.html#with_options/1"},{"type":"type","title":"Yex.Doc.t/0","doc":"","ref":"Yex.Doc.html#t:t/0"},{"type":"module","title":"Yex.Doc.Options","doc":"Document options.","ref":"Yex.Doc.Options.html"},{"type":"type","title":"Yex.Doc.Options.t/0","doc":"","ref":"Yex.Doc.Options.html#t:t/0"},{"type":"module","title":"Yex.Map","doc":"A shareable Map type.","ref":"Yex.Map.html"},{"type":"function","title":"Yex.Map.delete/2","doc":"delete a key from the map.","ref":"Yex.Map.html#delete/2"},{"type":"function","title":"Examples - Yex.Map.delete/2","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"plane\", [\"Hello\", \"World\"])\n    iex> Yex.Map.delete(map, \"plane\")\n    :ok","ref":"Yex.Map.html#delete/2-examples"},{"type":"function","title":"Yex.Map.fetch/2","doc":"get a key from the map.","ref":"Yex.Map.html#fetch/2"},{"type":"function","title":"Examples - Yex.Map.fetch/2","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"plane\", [\"Hello\", \"World\"])\n    iex> Yex.Map.fetch(map, \"plane\")\n    {:ok, [\"Hello\", \"World\"]}\n    iex> Yex.Map.fetch(map, \"not_found\")\n    :error","ref":"Yex.Map.html#fetch/2-examples"},{"type":"function","title":"Yex.Map.fetch!/2","doc":"","ref":"Yex.Map.html#fetch!/2"},{"type":"function","title":"Yex.Map.get/2","doc":"get a key from the map.","ref":"Yex.Map.html#get/2"},{"type":"function","title":"Examples - Yex.Map.get/2","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"plane\", [\"Hello\", \"World\"])\n    iex> Yex.Map.get(map, \"plane\")\n    {:ok, [\"Hello\", \"World\"]}\n    iex> Yex.Map.get(map, \"not_found\")\n    :error","ref":"Yex.Map.html#get/2-examples"},{"type":"function","title":"Yex.Map.set/3","doc":"set a key-value pair in the map.","ref":"Yex.Map.html#set/3"},{"type":"function","title":"Examples - Yex.Map.set/3","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"plane\", [\"Hello\", \"World\"])\n    :ok","ref":"Yex.Map.html#set/3-examples"},{"type":"function","title":"Yex.Map.size/1","doc":"","ref":"Yex.Map.html#size/1"},{"type":"function","title":"Yex.Map.to_json/1","doc":"Convert to json-compatible format.","ref":"Yex.Map.html#to_json/1"},{"type":"function","title":"Examples Sync two clients by exchanging the complete document structure - Yex.Map.to_json/1","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"array\", Yex.ArrayPrelim.from([\"Hello\", \"World\"]))\n    iex> Yex.Map.set(map, \"plane\", [\"Hello\", \"World\"])\n    iex> assert %{\"plane\" => [\"Hello\", \"World\"], \"array\" => [\"Hello\", \"World\"]} = Yex.Map.to_json(map)","ref":"Yex.Map.html#to_json/1-examples-sync-two-clients-by-exchanging-the-complete-document-structure"},{"type":"function","title":"Yex.Map.to_map/1","doc":"Convert to elixir map.","ref":"Yex.Map.html#to_map/1"},{"type":"function","title":"Examples - Yex.Map.to_map/1","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"array\", Yex.ArrayPrelim.from([\"Hello\", \"World\"]))\n    iex> Yex.Map.set(map, \"plane\", [\"Hello\", \"World\"])\n    iex> assert %{\"plane\" => [\"Hello\", \"World\"], \"array\" => %Yex.Array{}} = Yex.Map.to_map(map)","ref":"Yex.Map.html#to_map/1-examples"},{"type":"type","title":"Yex.Map.t/0","doc":"","ref":"Yex.Map.html#t:t/0"},{"type":"module","title":"Yex.MapPrelim","doc":"A preliminary map. It can be used to early initialize the contents of a Map.","ref":"Yex.MapPrelim.html"},{"type":"module","title":"Examples - Yex.MapPrelim","doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.insert(array, 0, Yex.MapPrelim.from(%{ \"key\" => \"value\" }))\n    iex> {:ok, %Yex.Map{} = map} = Yex.Array.fetch(array, 0)\n    iex> Yex.Map.fetch(map, \"key\")\n    {:ok, \"value\"}","ref":"Yex.MapPrelim.html#module-examples"},{"type":"function","title":"Yex.MapPrelim.from/1","doc":"","ref":"Yex.MapPrelim.html#from/1"},{"type":"type","title":"Yex.MapPrelim.t/0","doc":"","ref":"Yex.MapPrelim.html#t:t/0"},{"type":"module","title":"Yex.Sync","doc":"Sync protocol.","ref":"Yex.Sync.html"},{"type":"function","title":"Yex.Sync.get_sync_step1/1","doc":"Create a sync step 1 message based on the state of the current shared document.","ref":"Yex.Sync.html#get_sync_step1/1"},{"type":"function","title":"Yex.Sync.get_sync_step2/2","doc":"","ref":"Yex.Sync.html#get_sync_step2/2"},{"type":"function","title":"Yex.Sync.get_update/1","doc":"","ref":"Yex.Sync.html#get_update/1"},{"type":"function","title":"Yex.Sync.message_decode/1","doc":"","ref":"Yex.Sync.html#message_decode/1"},{"type":"function","title":"Yex.Sync.message_decode!/1","doc":"Decode a message.","ref":"Yex.Sync.html#message_decode!/1"},{"type":"function","title":"Examples - Yex.Sync.message_decode!/1","doc":"iex> Yex.Sync.message_decode(<<0, 0, 1,0>>)\n    {:ok, {:sync, {:sync_step1, <<0>>}}}","ref":"Yex.Sync.html#message_decode!/1-examples"},{"type":"function","title":"Yex.Sync.message_decode_v1/1","doc":"","ref":"Yex.Sync.html#message_decode_v1/1"},{"type":"function","title":"Yex.Sync.message_decode_v2/1","doc":"","ref":"Yex.Sync.html#message_decode_v2/1"},{"type":"function","title":"Yex.Sync.message_encode/1","doc":"Encode a message.","ref":"Yex.Sync.html#message_encode/1"},{"type":"function","title":"Examples - Yex.Sync.message_encode/1","doc":"iex> Yex.Sync.message_encode({:sync, {:sync_step1, <<0>>}})\n    {:ok, <<0, 0, 1,0>>}","ref":"Yex.Sync.html#message_encode/1-examples"},{"type":"function","title":"Yex.Sync.message_encode!/1","doc":"","ref":"Yex.Sync.html#message_encode!/1"},{"type":"function","title":"Yex.Sync.message_encode_v1/1","doc":"","ref":"Yex.Sync.html#message_encode_v1/1"},{"type":"function","title":"Yex.Sync.message_encode_v2/1","doc":"","ref":"Yex.Sync.html#message_encode_v2/1"},{"type":"function","title":"Yex.Sync.read_sync_message/3","doc":"","ref":"Yex.Sync.html#read_sync_message/3"},{"type":"function","title":"Yex.Sync.read_sync_step1/2","doc":"","ref":"Yex.Sync.html#read_sync_step1/2"},{"type":"function","title":"Yex.Sync.read_sync_step2/3","doc":"","ref":"Yex.Sync.html#read_sync_step2/3"},{"type":"type","title":"Yex.Sync.message/0","doc":"","ref":"Yex.Sync.html#t:message/0"},{"type":"type","title":"Yex.Sync.sync_message/0","doc":"","ref":"Yex.Sync.html#t:sync_message/0"},{"type":"module","title":"Yex.Sync.SharedDoc","doc":"This process handles messages for yjs protocol sync and awareness.\nhttps://github.com/yjs/y-protocols\n\nPersistence is supported by passing persistence module.\nsee Yex.Sync.SharedDoc.PersistenceBehaviour\n\nIf the observer process does not exist, it will automatically terminate.","ref":"Yex.Sync.SharedDoc.html"},{"type":"function","title":"Yex.Sync.SharedDoc.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Yex.Sync.SharedDoc.html#child_spec/1"},{"type":"function","title":"Yex.Sync.SharedDoc.observe/1","doc":"Receive doc update notifications in the calling process.","ref":"Yex.Sync.SharedDoc.html#observe/1"},{"type":"function","title":"Yex.Sync.SharedDoc.send_yjs_message/2","doc":"Send a message to the SharedDoc process.\nmessage mus be represented in the Yjs protocol default format.\ntype supports sync and awareness.","ref":"Yex.Sync.SharedDoc.html#send_yjs_message/2"},{"type":"function","title":"Yex.Sync.SharedDoc.start/2","doc":"Start the SharedDoc process.","ref":"Yex.Sync.SharedDoc.html#start/2"},{"type":"function","title":"Yex.Sync.SharedDoc.start_link/2","doc":"Start the SharedDoc process with a link.","ref":"Yex.Sync.SharedDoc.html#start_link/2"},{"type":"function","title":"Yex.Sync.SharedDoc.start_sync/2","doc":"Start the initial state exchange.","ref":"Yex.Sync.SharedDoc.html#start_sync/2"},{"type":"function","title":"Yex.Sync.SharedDoc.unobserve/1","doc":"Stop receiving doc update notifications in the calling process.\n\nIf auto_exit is started with true(default), the SharedDoc process will automatically stop when there is no longer a process to receive update notifications.","ref":"Yex.Sync.SharedDoc.html#unobserve/1"},{"type":"type","title":"Yex.Sync.SharedDoc.launch_param/0","doc":"Launch Parameters\n\n  * `:doc_name` - The name of the document.\n  * `:persistence` - Persistence module that implements PersistenceBehaviour.\n  * `:auto_exit` - Automatically terminate the SharedDoc process when there is no longer a process to receive update notifications.\n  * `:doc_option` - Options for the document.","ref":"Yex.Sync.SharedDoc.html#t:launch_param/0"},{"type":"behaviour","title":"Yex.Sync.SharedDoc.PersistenceBehaviour","doc":"Persistence behavior for SharedDoc","ref":"Yex.Sync.SharedDoc.PersistenceBehaviour.html"},{"type":"callback","title":"Yex.Sync.SharedDoc.PersistenceBehaviour.bind/3","doc":"Invoked to handle SharedDoc bind.\nMainly used to read and set the initial values of SharedDoc","ref":"Yex.Sync.SharedDoc.PersistenceBehaviour.html#c:bind/3"},{"type":"callback","title":"Examples save the state to the filesystem - Yex.Sync.SharedDoc.PersistenceBehaviour.bind/3","doc":"def bind(state, doc_name, doc) do\n    case File.read(\"path/to/\" <> doc_name, [:read, :binary]) do\n      {:ok, data} ->\n        Yex.apply_update(doc, data)\n\n      {:error, _} ->\n        :ok\n    end\n  end","ref":"Yex.Sync.SharedDoc.PersistenceBehaviour.html#c:bind/3-examples-save-the-state-to-the-filesystem"},{"type":"callback","title":"Yex.Sync.SharedDoc.PersistenceBehaviour.unbind/3","doc":"Invoked to handle SharedDoc terminate.\n\nThis is only executed when SharedDoc exits successfully.","ref":"Yex.Sync.SharedDoc.PersistenceBehaviour.html#c:unbind/3"},{"type":"callback","title":"Examples save the state to the filesystem - Yex.Sync.SharedDoc.PersistenceBehaviour.unbind/3","doc":"def unbind(state, doc_name, doc) do\n      case Yex.encode_state_as_update(doc) do\n        {:ok, update} ->\n          File.write!(\"path/to/\" <> doc_name, update, [:write, :binary])\n        error ->\n          error\n      end\n\n      :ok\n    end","ref":"Yex.Sync.SharedDoc.PersistenceBehaviour.html#c:unbind/3-examples-save-the-state-to-the-filesystem"},{"type":"callback","title":"Yex.Sync.SharedDoc.PersistenceBehaviour.update_v1/4","doc":"Invoked to handle all doc updates.","ref":"Yex.Sync.SharedDoc.PersistenceBehaviour.html#c:update_v1/4"},{"type":"module","title":"Yex.Text","doc":"A shareable type that is optimized for shared editing on text.","ref":"Yex.Text.html"},{"type":"function","title":"Yex.Text.apply_delta/2","doc":"Transforms this type to a Quill Delta","ref":"Yex.Text.html#apply_delta/2"},{"type":"function","title":"Examples Sync two clients by exchanging the complete document structure - Yex.Text.apply_delta/2","doc":"iex> doc = Yex.Doc.new()\n    iex> text = Yex.Doc.get_text(doc, \"text\")\n    iex> delta = [%{ \"retain\" => 1}, %{ \"delete\" => 3}]\n    iex> Yex.Text.insert(text,0, \"12345\")\n    iex> Yex.Text.apply_delta(text,delta)\n    iex> Yex.Text.to_delta(text)\n    [%{insert: \"15\"}]","ref":"Yex.Text.html#apply_delta/2-examples-sync-two-clients-by-exchanging-the-complete-document-structure"},{"type":"function","title":"Yex.Text.delete/3","doc":"","ref":"Yex.Text.html#delete/3"},{"type":"function","title":"Yex.Text.format/4","doc":"","ref":"Yex.Text.html#format/4"},{"type":"function","title":"Yex.Text.insert/3","doc":"","ref":"Yex.Text.html#insert/3"},{"type":"function","title":"Yex.Text.insert/4","doc":"","ref":"Yex.Text.html#insert/4"},{"type":"function","title":"Yex.Text.length/1","doc":"","ref":"Yex.Text.html#length/1"},{"type":"function","title":"Yex.Text.to_delta/1","doc":"Transforms this type to a Quill Delta","ref":"Yex.Text.html#to_delta/1"},{"type":"function","title":"Examples Sync two clients by exchanging the complete document structure - Yex.Text.to_delta/1","doc":"iex> doc = Yex.Doc.new()\n    iex> text = Yex.Doc.get_text(doc, \"text\")\n    iex> Yex.Text.insert(text, 0, \"12345\")\n    iex> Yex.Text.insert(text, 0, \"0\", %{\"bold\" => true})\n    iex> Yex.Text.to_delta(text)\n    [%{insert: \"0\", attributes: %{\"bold\" => true}}, %{insert: \"12345\"}]","ref":"Yex.Text.html#to_delta/1-examples-sync-two-clients-by-exchanging-the-complete-document-structure"},{"type":"function","title":"Yex.Text.to_string/1","doc":"","ref":"Yex.Text.html#to_string/1"},{"type":"type","title":"Yex.Text.delta/0","doc":"","ref":"Yex.Text.html#t:delta/0"},{"type":"type","title":"Yex.Text.t/0","doc":"","ref":"Yex.Text.html#t:t/0"},{"type":"module","title":"Yex.TextPrelim","doc":"A preliminary text. It can be used to early initialize the contents of a Text.","ref":"Yex.TextPrelim.html"},{"type":"module","title":"Examples - Yex.TextPrelim","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"key\", Yex.TextPrelim.from(\"Hello World\"))\n    iex> {:ok, %Yex.Text{} = text} = Yex.Map.fetch(map, \"key\")\n    iex> Yex.Text.to_delta(text)\n    [%{insert: \"Hello World\"}]","ref":"Yex.TextPrelim.html#module-examples"},{"type":"function","title":"Yex.TextPrelim.from/1","doc":"Transforms a Text to a TextPrelim","ref":"Yex.TextPrelim.html#from/1"},{"type":"function","title":"Examples with a binary - Yex.TextPrelim.from/1","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"key\", Yex.TextPrelim.from(\"Hello World\"))\n    iex> {:ok, %Yex.Text{} = text} = Yex.Map.fetch(map, \"key\")\n    iex> Yex.Text.to_delta(text)\n    [%{insert: \"Hello World\"}]","ref":"Yex.TextPrelim.html#from/1-examples-with-a-binary"},{"type":"function","title":"Examples with delta - Yex.TextPrelim.from/1","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"key\", Yex.TextPrelim.from([%{insert: \"Hello\"},%{insert: \" World\", attributes: %{ \"bold\" => true }},]))\n    iex> {:ok, %Yex.Text{} = text} = Yex.Map.fetch(map, \"key\")\n    iex> Yex.Text.to_delta(text)\n    [%{insert: \"Hello\"}, %{attributes: %{\"bold\" => true}, insert: \" World\"}]","ref":"Yex.TextPrelim.html#from/1-examples-with-delta"},{"type":"type","title":"Yex.TextPrelim.t/0","doc":"","ref":"Yex.TextPrelim.html#t:t/0"},{"type":"protocol","title":"Yex.Xml","doc":"","ref":"Yex.Xml.html"},{"type":"function","title":"Yex.Xml.next_sibling/1","doc":"","ref":"Yex.Xml.html#next_sibling/1"},{"type":"function","title":"Yex.Xml.parent/1","doc":"","ref":"Yex.Xml.html#parent/1"},{"type":"function","title":"Yex.Xml.prev_sibling/1","doc":"","ref":"Yex.Xml.html#prev_sibling/1"},{"type":"function","title":"Yex.Xml.to_string/1","doc":"","ref":"Yex.Xml.html#to_string/1"},{"type":"type","title":"Yex.Xml.t/0","doc":"All the types that implement this protocol.","ref":"Yex.Xml.html#t:t/0"},{"type":"module","title":"Yex.XmlElement","doc":"A shared type that represents an XML node","ref":"Yex.XmlElement.html"},{"type":"function","title":"Yex.XmlElement.children/1","doc":"","ref":"Yex.XmlElement.html#children/1"},{"type":"function","title":"Yex.XmlElement.delete/3","doc":"","ref":"Yex.XmlElement.html#delete/3"},{"type":"function","title":"Yex.XmlElement.fetch/2","doc":"","ref":"Yex.XmlElement.html#fetch/2"},{"type":"function","title":"Yex.XmlElement.fetch!/2","doc":"","ref":"Yex.XmlElement.html#fetch!/2"},{"type":"function","title":"Yex.XmlElement.first_child/1","doc":"","ref":"Yex.XmlElement.html#first_child/1"},{"type":"function","title":"Yex.XmlElement.get/2","doc":"","ref":"Yex.XmlElement.html#get/2"},{"type":"function","title":"Yex.XmlElement.get_attribute/2","doc":"","ref":"Yex.XmlElement.html#get_attribute/2"},{"type":"function","title":"Yex.XmlElement.get_attributes/1","doc":"","ref":"Yex.XmlElement.html#get_attributes/1"},{"type":"function","title":"Yex.XmlElement.insert/3","doc":"","ref":"Yex.XmlElement.html#insert/3"},{"type":"function","title":"Yex.XmlElement.insert_after/3","doc":"","ref":"Yex.XmlElement.html#insert_after/3"},{"type":"function","title":"Yex.XmlElement.insert_attribute/3","doc":"","ref":"Yex.XmlElement.html#insert_attribute/3"},{"type":"function","title":"Yex.XmlElement.length/1","doc":"","ref":"Yex.XmlElement.html#length/1"},{"type":"function","title":"Yex.XmlElement.next_sibling/1","doc":"The next sibling of this type. Is null if this is the last child of its parent.","ref":"Yex.XmlElement.html#next_sibling/1"},{"type":"function","title":"Yex.XmlElement.parent/1","doc":"The parent that holds this type. Is null if this xml is a top-level XML type.","ref":"Yex.XmlElement.html#parent/1"},{"type":"function","title":"Yex.XmlElement.prev_sibling/1","doc":"The previous sibling of this type. Is null if this is the first child of its parent.","ref":"Yex.XmlElement.html#prev_sibling/1"},{"type":"function","title":"Yex.XmlElement.push/2","doc":"","ref":"Yex.XmlElement.html#push/2"},{"type":"function","title":"Yex.XmlElement.remove_attribute/2","doc":"","ref":"Yex.XmlElement.html#remove_attribute/2"},{"type":"function","title":"Yex.XmlElement.to_string/1","doc":"","ref":"Yex.XmlElement.html#to_string/1"},{"type":"function","title":"Yex.XmlElement.unshift/2","doc":"","ref":"Yex.XmlElement.html#unshift/2"},{"type":"type","title":"Yex.XmlElement.t/0","doc":"","ref":"Yex.XmlElement.html#t:t/0"},{"type":"module","title":"Yex.XmlElementPrelim","doc":"A preliminary xml element. It can be used to early initialize the contents of a XmlElement.","ref":"Yex.XmlElementPrelim.html"},{"type":"module","title":"Examples - Yex.XmlElementPrelim","doc":"iex> doc = Yex.Doc.new()\n    iex> xml = Yex.Doc.get_xml_fragment(doc, \"xml\")\n    iex> Yex.XmlFragment.insert(xml, 0,  Yex.XmlElementPrelim.empty(\"div\"))\n    iex> Yex.XmlFragment.to_string(xml)\n    \"  \"","ref":"Yex.XmlElementPrelim.html#module-examples"},{"type":"function","title":"Yex.XmlElementPrelim.empty/1","doc":"","ref":"Yex.XmlElementPrelim.html#empty/1"},{"type":"function","title":"Yex.XmlElementPrelim.new/2","doc":"","ref":"Yex.XmlElementPrelim.html#new/2"},{"type":"type","title":"Yex.XmlElementPrelim.t/0","doc":"","ref":"Yex.XmlElementPrelim.html#t:t/0"},{"type":"module","title":"Yex.XmlFragment","doc":"A shared type to manage a collection of Y.Xml* Nodes","ref":"Yex.XmlFragment.html"},{"type":"function","title":"Yex.XmlFragment.children/1","doc":"","ref":"Yex.XmlFragment.html#children/1"},{"type":"function","title":"Yex.XmlFragment.delete/3","doc":"","ref":"Yex.XmlFragment.html#delete/3"},{"type":"function","title":"Yex.XmlFragment.fetch/2","doc":"","ref":"Yex.XmlFragment.html#fetch/2"},{"type":"function","title":"Yex.XmlFragment.fetch!/2","doc":"","ref":"Yex.XmlFragment.html#fetch!/2"},{"type":"function","title":"Yex.XmlFragment.first_child/1","doc":"","ref":"Yex.XmlFragment.html#first_child/1"},{"type":"function","title":"Yex.XmlFragment.get/2","doc":"","ref":"Yex.XmlFragment.html#get/2"},{"type":"function","title":"Yex.XmlFragment.insert/3","doc":"","ref":"Yex.XmlFragment.html#insert/3"},{"type":"function","title":"Yex.XmlFragment.insert_after/3","doc":"","ref":"Yex.XmlFragment.html#insert_after/3"},{"type":"function","title":"Yex.XmlFragment.length/1","doc":"","ref":"Yex.XmlFragment.html#length/1"},{"type":"function","title":"Yex.XmlFragment.parent/1","doc":"The parent that holds this type. Is null if this xml is a top-level XML type.","ref":"Yex.XmlFragment.html#parent/1"},{"type":"function","title":"Yex.XmlFragment.push/2","doc":"","ref":"Yex.XmlFragment.html#push/2"},{"type":"function","title":"Yex.XmlFragment.to_string/1","doc":"","ref":"Yex.XmlFragment.html#to_string/1"},{"type":"function","title":"Yex.XmlFragment.unshift/2","doc":"","ref":"Yex.XmlFragment.html#unshift/2"},{"type":"type","title":"Yex.XmlFragment.t/0","doc":"","ref":"Yex.XmlFragment.html#t:t/0"},{"type":"module","title":"Yex.XmlFragmentPrelim","doc":"A preliminary xml fragment. It can be used to early initialize the contents of a XmlFragment.","ref":"Yex.XmlFragmentPrelim.html"},{"type":"module","title":"Examples - Yex.XmlFragmentPrelim","doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.insert(array, 0,  Yex.XmlFragmentPrelim.new([Yex.XmlElementPrelim.empty(\"div\")]))\n    iex> {:ok, %Yex.XmlFragment{} = fragment} = Yex.Array.fetch(array, 0)\n    iex> Yex.XmlFragment.to_string(fragment)\n    \"  \"","ref":"Yex.XmlFragmentPrelim.html#module-examples"},{"type":"function","title":"Yex.XmlFragmentPrelim.new/1","doc":"","ref":"Yex.XmlFragmentPrelim.html#new/1"},{"type":"type","title":"Yex.XmlFragmentPrelim.t/0","doc":"","ref":"Yex.XmlFragmentPrelim.html#t:t/0"},{"type":"module","title":"Yex.XmlText","doc":"Extends Y.Text to represent a Y.Xml node.","ref":"Yex.XmlText.html"},{"type":"function","title":"Yex.XmlText.apply_delta/2","doc":"","ref":"Yex.XmlText.html#apply_delta/2"},{"type":"function","title":"Yex.XmlText.delete/3","doc":"","ref":"Yex.XmlText.html#delete/3"},{"type":"function","title":"Yex.XmlText.format/4","doc":"","ref":"Yex.XmlText.html#format/4"},{"type":"function","title":"Yex.XmlText.insert/3","doc":"","ref":"Yex.XmlText.html#insert/3"},{"type":"function","title":"Yex.XmlText.insert/4","doc":"","ref":"Yex.XmlText.html#insert/4"},{"type":"function","title":"Yex.XmlText.length/1","doc":"","ref":"Yex.XmlText.html#length/1"},{"type":"function","title":"Yex.XmlText.next_sibling/1","doc":"The next sibling of this type. Is null if this is the last child of its parent.","ref":"Yex.XmlText.html#next_sibling/1"},{"type":"function","title":"Yex.XmlText.parent/1","doc":"The parent that holds this type. Is null if this xml is a top-level XML type.","ref":"Yex.XmlText.html#parent/1"},{"type":"function","title":"Yex.XmlText.prev_sibling/1","doc":"The previous sibling of this type. Is null if this is the first child of its parent.","ref":"Yex.XmlText.html#prev_sibling/1"},{"type":"function","title":"Yex.XmlText.to_delta/1","doc":"","ref":"Yex.XmlText.html#to_delta/1"},{"type":"function","title":"Yex.XmlText.to_string/1","doc":"","ref":"Yex.XmlText.html#to_string/1"},{"type":"type","title":"Yex.XmlText.delta/0","doc":"","ref":"Yex.XmlText.html#t:delta/0"},{"type":"type","title":"Yex.XmlText.t/0","doc":"","ref":"Yex.XmlText.html#t:t/0"},{"type":"module","title":"Yex.XmlTextPrelim","doc":"A preliminary xml text. It can be used to early initialize the contents of a XmlText.","ref":"Yex.XmlTextPrelim.html"},{"type":"module","title":"Examples - Yex.XmlTextPrelim","doc":"iex> doc = Yex.Doc.new()\n    iex> xml = Yex.Doc.get_xml_fragment(doc, \"xml\")\n    iex> Yex.XmlFragment.insert(xml, 0,  Yex.XmlTextPrelim.from(\"Hello World\"))\n    iex> {:ok, %Yex.XmlText{} = text} = Yex.XmlFragment.fetch(xml, 0)\n    iex> Yex.XmlText.to_delta(text)\n    [%{insert: \"Hello World\"}]","ref":"Yex.XmlTextPrelim.html#module-examples"},{"type":"function","title":"Yex.XmlTextPrelim.from/1","doc":"Transforms a Text to a TextPrelim","ref":"Yex.XmlTextPrelim.html#from/1"},{"type":"function","title":"Examples with a binary - Yex.XmlTextPrelim.from/1","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"key\", Yex.XmlTextPrelim.from(\"Hello World\"))\n    iex> {:ok, %Yex.XmlText{} = text} = Yex.Map.fetch(map, \"key\")\n    iex> Yex.XmlText.to_delta(text)\n    [%{insert: \"Hello World\"}]","ref":"Yex.XmlTextPrelim.html#from/1-examples-with-a-binary"},{"type":"function","title":"Examples with delta - Yex.XmlTextPrelim.from/1","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"key\", Yex.XmlTextPrelim.from([%{insert: \"Hello\"},%{insert: \" World\", attributes: %{ \"bold\" => true }},]))\n    iex> {:ok,%Yex.XmlText{} = text} = Yex.Map.fetch(map, \"key\")\n    iex> Yex.XmlText.to_delta(text)\n    [%{insert: \"Hello\"}, %{attributes: %{\"bold\" => true}, insert: \" World\"}]","ref":"Yex.XmlTextPrelim.html#from/1-examples-with-delta"},{"type":"type","title":"Yex.XmlTextPrelim.t/0","doc":"","ref":"Yex.XmlTextPrelim.html#t:t/0"},{"type":"exception","title":"Yex.DeletedSharedTypeError","doc":"","ref":"Yex.DeletedSharedTypeError.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}